package com.fp.persistence.pgeneral.score;

import java.sql.Timestamp;
import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import com.fp.dto.hb.History;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEPERCENTSCORE*/
@Embeddable
public class TgenePercentScoreKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId,History{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="SCORECODE", nullable=false,updatable=false)

/**
* Codigo de calificacion con el cual se realiza el calculo de provisiones
*/
private String scorecode;

@Column(name="CREDITTYPECODE", nullable=false,updatable=false)

/**
* Codigo de tipo de credito
*/
private String credittypecode;

@Column(name="DATETO", nullable=false,updatable=false)

/**
* Fecha hasta la cual esta vigente el porcentaje de provision de acuerdo a la calificacion 
*/
private Timestamp dateto;

/**Contructor por defecto*/
public TgenePercentScoreKey(){}
/**Contructor de TgenePercentScoreKey
@param pScorecode Codigo de calificacion con el cual se realiza el calculo de provisiones
@param pCredittypecode Codigo de tipo de credito
@param pDateto Fecha hasta la cual esta vigente el porcentaje de provision de acuerdo a la calificacion 
*/
public TgenePercentScoreKey(String pScorecode,String pCredittypecode,Timestamp pDateto){
 scorecode=pScorecode;
 credittypecode=pCredittypecode;
 dateto=pDateto;
}
/**Obtiene el valor de scorecode
@return valor de scorecode*/
public String getScorecode(){
  return scorecode;
}
/**Fija el valor de scorecode
@param pScorecode nuevo Valor de scorecode*/
public void setScorecode(String pScorecode){
  scorecode=pScorecode;
}

/**Obtiene el valor de credittypecode
@return valor de credittypecode*/
public String getCredittypecode(){
  return credittypecode;
}
/**Fija el valor de credittypecode
@param pCredittypecode nuevo Valor de credittypecode*/
public void setCredittypecode(String pCredittypecode){
  credittypecode=pCredittypecode;
}

/**Obtiene el valor de dateto
@return valor de dateto*/
public Timestamp getDateto(){
  return dateto;
}
/**Fija el valor de dateto
@param pDateto nuevo Valor de dateto*/
public void setDateto(Timestamp pDateto){
  dateto=pDateto;
}

/**Implementación de la comparación de TgenePercentScoreKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgenePercentScoreKey))return false;
  TgenePercentScoreKey that = (TgenePercentScoreKey) o;
  if (this.getScorecode() == null || that.getScorecode() == null){
      return false;
  }
  if (! this.getScorecode().equals(that.getScorecode())){
    return false;
  }
  if (this.getCredittypecode() == null || that.getCredittypecode() == null){
      return false;
  }
  if (! this.getCredittypecode().equals(that.getCredittypecode())){
    return false;
  }
  if (this.getDateto() == null || that.getDateto() == null){
      return false;
  }
  if (! this.getDateto().equals(that.getDateto())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgenePercentScoreKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getScorecode() == null ? 0 : this.getScorecode().hashCode());
    result = result * 37 + (this.getCredittypecode() == null ? 0 : this.getCredittypecode().hashCode());
    result = result * 37 + (this.getDateto() == null ? 0 : this.getDateto().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
public Object getId() {
  return null;
}
}
